#!/usr/bin/env python
from __future__ import generators
import findrox; findrox.version(1,9,12)
import rox
from rox import applet, g, InfoWin, tasks, ButtonMixed, choices, options
from rox.options import Option
import sys

from xml.dom import minidom
import xml.sax
import urllib

import gc
import os
import re
import gobject

import tool

global v

V = "0.4.3"
Version = "RETicker v " + V

def init_options(user_conf):

	pos = V.find(".") + 1
	pos += V[pos:].find(".")
	program = "RETicker_" + V[:pos]	+ user_conf
	
	rox.setup_app_options(program)
	
	global my_menu
	import my_menu
	my_menu.set_save(program)
	
	# Quell-Optionen
	global news_age; news_age = Option('news_age', '60') # in Min
	global news_showcount; news_showcount = Option('news_showcount', '0')
	global sources; sources=Option('sources', "<Options><source><active>1</active><ticker>http://slashdot.org/slashdot.rdf</ticker><icon>http://slashdot.org/favicon.ico</icon><iconcache></iconcache><shownews>5</shownews></source></Options>")
	
	# Layout-Optionen (Ticker)
	global text_color; text_color = Option('text_color', '#880000')
	global use_back_color; use_back_color = Option('use_back_color', '0') #new
	global back_color; back_color = Option('back_color', '#808080') #new
	global transparent; transparent = Option('transparent', '0')
	global back_datei; back_datei = Option('back_datei', '')
	global hor_size; hor_size=Option('hor_size', '-1')
	global ver_size; ver_size=Option('ver_size', '20')
	
	# Layout-Optionen (Spezial-Window)
	global show_age; show_age = Option('show_age', '1') #new
	global show_stat; show_stat = Option('show_stat', '1') #new
	global color_new_msg; color_new_msg = Option('color_new_msg', '#880000') #new
	global color_old_msg; color_old_msg = Option('color_old_msg', '#000000') #new
	global color_not_shown_msg; color_not_shown_msg = Option('color_not_shown_msg', '#666666') #new

	# Tooltip-Design Label
	global tt_l; tt_l=Option('tt_l', '1') # zeigt Label-ToolTip mit Description an
	global tt_l_frame; tt_l_frame=Option('tt_l_frame', '1')
	global tt_l_title; tt_l_title=Option('tt_l_title', '1')
	global tt_l_link; tt_l_link=Option('tt_l_link', '1')
	global tt_l_ver; tt_l_ver=Option('tt_l_ver', '1')
	
	# Tooltip-Design Image
	global tt_i; tt_i=Option('tt_i', '1') # zeigt Image-ToolTip mit Description an
	global tt_i_frame; tt_i_frame=Option('tt_i_frame', '1')
	global tt_i_title; tt_i_title=Option('tt_i_title', '1')
	global tt_i_desc; tt_i_desc=Option('tt_i_desc', '1')
	global tt_i_src; tt_i_src=Option('tt_i_src', '1')
	global tt_i_link; tt_i_link=Option('tt_i_link', '1')
	global tt_i_ver; tt_i_ver=Option('tt_i_ver', '1')

	# Fetch-Optionen
	global update_time; update_time = Option('update_time', '15') # in sec.
	global refresh_time; refresh_time= Option('refresh_time', '30') # in Min
	global check_verbose; check_verbose=Option('check_verbose', '1')
	global check_image; check_image=Option('check_image', '0')
	
	# diverse Pfade und Browser
	global browser; browser= Option('browser', 'opera')
	global br_options; br_options= Option('br_options', '-newpage')
	try:
		path = os.environ['CHOICESPATH']
		paths = path.split(':')
	except KeyError:
		paths = [ os.environ['HOME'] + '/Choices',
			  '/usr/local/share/Choices',
			  '/usr/share/Choices' ]
	cache = paths[0] + '/' + program
	if not(os.path.exists(cache)): os.mkdir(cache)
	xml_cache_ = cache + "/xml_cache"
	if not(os.path.exists(xml_cache_)): os.mkdir(xml_cache_)
	xml_cache_ += "/News.xml"
	global xml_cache; xml_cache=Option('xml_cache', xml_cache_)
	icon_cache = cache + "/icon_cache"
	if not(os.path.exists(icon_cache)): os.mkdir(icon_cache)
	global icon_cache_dir; icon_cache_dir=Option('icon_cache_dir', icon_cache)

	
	rox.app_options.notify()
	

def unxml(string):
	""" removes entities from a given string and returns new string """
	lt=re.compile('&lt;')
	gt=re.compile('&gt;')
	amp=re.compile('&amp;')
	auml=re.compile('&auml;|&#228;')
	Auml=re.compile('&Auml;')
	ouml=re.compile('&ouml;|&#246;')
	Ouml=re.compile('&Ouml;')
	uuml=re.compile('&uuml;|&#252;')
	Uuml=re.compile('&Uuml;')
	szlig=re.compile('&szlig;|&#223;')
	quot=re.compile('&quot;')
	apos=re.compile('&apos;')
	#tag=re.compile('<.*?>')
	(string,null)=amp.subn("&",string,0)
	(string,null)=auml.subn(u'\xE4',string,0)
	(string,null)=Auml.subn(u'\xC4',string,0)
	(string,null)=ouml.subn(u'\xF6',string,0)
	(string,null)=Ouml.subn(u'\xD5',string,0)
	(string,null)=Uuml.subn(u'\xDC',string,0)
	(string,null)=szlig.subn(u'\xDF',string,0)
	(string,null)=uuml.subn(u'\xFC',string,0)
	(string,null)=quot.subn('"',string,0)
	(string,null)=apos.subn("'",string,0)
	(string,null)=lt.subn("<",string,0)
	(string,null)=gt.subn(">",string,0)
	#(string,null)=tag.subn("",string,0)
	return string


import rox.OptionsBox
from rox.OptionsBox import data
class OptionsBox(rox.OptionsBox.OptionsBox):
	def build_image(self, node, image):
		"""<image>Text</image>"""
		image = g.Image()
		Filename = rox.app_dir + "/" + data(node)
    		if os.path.exists(Filename):
    			image.set_from_file(Filename)
		else:
			image.set_from_stock(g.STOCK_MISSING_IMAGE,g.ICON_SIZE_SMALL_TOOLBAR)
		return [image]	

	def build_tickerconf(self, node, label, option):
		"""<tickerconf>alle tags als xml</tickerconf>"""
		PrefTab = TickPrefs_Container()
		self.may_add_tip(PrefTab, node)
		PrefTab.connect('changed_Conti', lambda t,w: self.check_widget(option))
		def get():
			return PrefTab.get_value()
		def set():
			PrefTab.load_config(option.value)
		self.handlers[option] = (get, set)
		return [PrefTab]
	def build_help(self, node, label):
		"""<help>gib ein Infofenster aus</help>"""
		HelpTab = Help_Container()
		return [HelpTab]
	def build_info(self, node, label):
		"""<info>gib ein Infofenster aus</info>"""
		InfoTab = Info_Container()
		return [InfoTab]
	def build_fileentry(self, node, label, option):
		"<fileentry name='...' label='...'>Tooltip</fileentry>"
		def open_cache_file(widget, event):
			def set_cache_file(widget):
				sel.hide()
				entry.set_text(sel.get_filename())
			def exit(widget):
				sel.hide()
			if event.button == 1:
				sel = g.FileSelection()
				sel.set_filename(entry.get_text())
				sel.connect("destroy", exit)
				sel.ok_button.connect("clicked", set_cache_file)
				sel.cancel_button.connect("clicked", exit)
				sel.show()
		box = g.HBox(False, 4)
		entry = g.Entry()
		button1 = g.EventBox()
		button1.show()
		b_image = g.Image()
		b_image.set_from_stock(g.STOCK_OPEN,g.ICON_SIZE_SMALL_TOOLBAR)
		b_image.show()
		button1.add(b_image)
		button1.connect('button_press_event', open_cache_file)

		if label:
			label_wid = g.Label(label)
			label_wid.set_alignment(1.0, 0.5)
			box.pack_start(label_wid, False, True, 0)
		box.pack_start(entry, True, True, 0)
		box.pack_start(button1, True, True, 0)
		
		self.may_add_tip(entry, node)

		entry.connect('changed', lambda e: self.check_widget(option))

		def get():
			return entry.get_chars(0, -1)
		def set():
			entry.set_text(option.value)
		self.handlers[option] = (get, set)

		return [box]

class Icon_Image(g.Image):
	def __init__(self):
		g.Image.__init__(self)
    		self.pxbuf = g.gdk.pixbuf_new_from_file(rox.app_dir+"/AppIcon.xpm")
		self.img_pxbuf = g.gdk.pixbuf_new_from_file(rox.app_dir+"/AppIcon.xpm")
		self.saturation = 0.01
		self.pxbuf.saturate_and_pixelate(self.pxbuf, self.saturation, False)
		self.get_from_file(rox.app_dir+"/AppIcon.xpm")
		self.show()
		self.setStockNo()
	def set_active(self, active):
		if active == 1: self.saturation = 1
		else: self.saturation = 0.01
		self.show_img()
	def show_img(self):
		if self.saturation <> 1:
			self.pxbuf.saturate_and_pixelate(self.img_pxbuf, self.saturation, True)
		else: self.pxbuf.saturate_and_pixelate(self.img_pxbuf, self.saturation, False)
		im_icon_set = g.IconSet(self.img_pxbuf)
    		self.set_from_icon_set(im_icon_set,g.ICON_SIZE_SMALL_TOOLBAR)
	def get_from_file(self,Filename):
    		if os.path.isfile(Filename):
			del self.pxbuf
			del self.img_pxbuf
			gc.collect()
			self.pxbuf = g.gdk.pixbuf_new_from_file(Filename)
			self.img_pxbuf = g.gdk.pixbuf_new_from_file(Filename)
			self.show_img()
			return 1
		else:
			self.setStockMissing()
			return 0
	def get_from_uri(self,uri,file):
		self.setStockRefresh()
		try:
			urllib.urlretrieve(uri,file)
			self.get_from_file(file)
		except (IOError, EOFError):
			self.setStockCancel()
	def setStockNo(self):
		self.set_from_stock(g.STOCK_NO,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockJump(self):
		self.set_from_stock(g.STOCK_JUMP_TO,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockCancel(self):
		self.set_from_stock(g.STOCK_CANCEL,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockRefresh(self):
		self.set_from_stock(g.STOCK_REFRESH,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockConvert(self):
		self.set_from_stock(g.STOCK_CONVERT,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockMissing(self):
		self.set_from_stock(g.STOCK_MISSING_IMAGE,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockAdd(self):
		self.set_from_stock(g.STOCK_ADD,g.ICON_SIZE_SMALL_TOOLBAR)

class ConfigPage(g.Fixed):
        def __init__(self):
		g.Fixed.__init__(self)
		#self.entry={"ticker":ticker,"icon":iconname,"title":"",\
	    	#		"link":"","desc":"" }
		self.show
		######### set labels
		label1 = g.Label("max. Number of News ...")
		label1.show()
		self.put (label1, 190, 48)
		label1.set_size_request(-1, 16)
		label1.set_line_wrap(True)
		label1b = g.Label("to show in Ticker")
		label1b.show()
		self.put (label1b, 193, 60)
		label1b.set_size_request(40, 32)
		label1b.set_line_wrap(True)
		label2 = g.Label("source html-adress")
		label2.show()
		self.put (label2, 30, 0)
		label2.set_size_request(-1, 16)
		label3 = g.Label("Icon html-adress")
		label3.show()
		self.put (label3, 8, 50)
		label3.set_size_request(-1, 16)
		label4 = g.Label("local Icon (or cache adress)")
		label4.show()
		self.put (label4, 8, 98)
		label4.set_size_request(-1, 16)
		self.label5 = g.Label("[ icon in cachdir - see path conf ]")
		#label5.show()
		self.put (self.label5, 8, 133)
		self.label5.set_size_request(-1, 16)
		########## set button
		#button3 = g.Button("fetch to local File now")
		#button3.show()
		#self.put (button3, 170, 121)
		#button3.set_size_request(-1,22)
		#button3.connect('clicked', self.fetch_icon)

		button1 = g.EventBox()
		button1.show()
		b_image = g.Image()
		b_image.set_from_stock(g.STOCK_OPEN,g.ICON_SIZE_SMALL_TOOLBAR)
		b_image.show()
		button1.add(b_image)
		self.put (button1, 148, 98)
		tip1 = g.Tooltips()
		tip1.enable()
		tip1.set_tip(button1,"Press to choose file", None)
		button1.connect('button_press_event', self.open_cache_file)

		button2 = g.EventBox()
		button2.show()
		self.b_image_2 = g.Image()
		self.b_image_2.set_from_stock(g.STOCK_NO,g.ICON_SIZE_SMALL_TOOLBAR)
		self.b_image_2.show()
		button2.add(self.b_image_2)
		self.put (button2, 8, 10)
		tip2 = g.Tooltips()
		tip2.enable()
		tip2.set_tip(button1,"Press to switch activity", None)
		button2.connect('button_press_event', self.switch_active)

		button3 = g.EventBox()
		button3.show()
		b_image_3 = g.Image()
		b_image_3.set_from_stock(g.STOCK_CONVERT,g.ICON_SIZE_SMALL_TOOLBAR)
		b_image_3.show()
		button3.add(b_image_3)
		self.put (button3, 148, 46)
		tip3 = g.Tooltips()
		tip3.enable()
		tip3.set_tip(button1,"Press to fetch icon", None)
		button3.connect('button_press_event', self.fetch_icon)

		########## set entrys
		self.e_ticker = g.Entry()
		self.e_ticker.show()
		self.put (self.e_ticker, 30, 14)
		self.e_ticker.set_size_request(248,22)
		self.e_icon = g.Entry()
		self.e_icon.show()
		self.put (self.e_icon, 8, 66)
		self.e_icon.set_size_request(158,22)
		self.e_iconcache = g.Entry()
		self.e_iconcache.show()
		self.put (self.e_iconcache, 8, 114)
		self.e_iconcache.set_size_request(158,22)
		######### set Spin
		self.s_shownews = g.SpinButton(g.Adjustment(5, 1, 300, 1, 10, 10))
		self.s_shownews.show()
		self.put (self.s_shownews, 265, 66)
		self.s_shownews.set_size_request(45,22)
		######### set Check
		#self.c_active = g.CheckButton("active")
		#self.c_active.show()
		#self.put (self.c_active, 6, 6)
		#self.c_active.set_size_request(-1, 24)
		########
		self.icon_image_tab = Icon_Image()
		self.icon_image_tab.show()
		####### date-infos ###################################
		self.date_hsep_a = g.HSeparator()
		self.date_hsep_a.set_size_request(10,-1)
		self.put (self.date_hsep_a, 181, 103)
		self.date_hsep_b = g.HSeparator()
		self.date_hsep_b.set_size_request(10,-1)
		self.put (self.date_hsep_b, 311, 103)
		self.date_label_a = g.Label("[ticker provides date info]")
		self.put (self.date_label_a, 193, 95)
		self.date_label_a.set_size_request(115, 16)
		self.date_label_a.modify_fg(g.STATE_NORMAL, g.gdk.color_parse('#008000'))
		self.date_label_b = g.Label("max news-age (0 to ignore)")
		self.put (self.date_label_b, 190, 107)
		self.date_label_b.set_size_request(-1, 16)
		self.date_label_b.set_line_wrap(True)
		self.date_label_c = g.Label("minutes")
		self.put (self.date_label_c, 193, 126)
		self.date_label_c.set_size_request(-1, 16)
		self.s_news_age_by_date = g.SpinButton(g.Adjustment(5, 0, 300, 1, 10, 10))
		self.put (self.s_news_age_by_date, 265, 125)
		self.s_news_age_by_date.set_size_request(45,22)
		########
		hsep = g.HSeparator()
		hsep.show()
		hsep.set_size_request(320,-1)
		self.put (hsep, 3, 42)
		vsep = g.VSeparator()
		vsep.show()
		vsep.set_size_request(-1,95)
		self.put (vsep, 180, 43)
		#self.add(hsep)
		self.active = 0
		self.ticker = ""
		self.icon = ""
		self.def_icon = "" # default icon position
		self.iconcache = ""
		self.def_iconcache = "" # default icon position in cache
		self.news_age_by_date = 0
		self.shownews = 5
		self.sig_ticker = None
		self.sig_icon = None
		self.sig_iconcache = None
		self.sig_news_age_by_date = None
		self.sig_shownews = None
		self.sig_active = None
		self.block_sig_ticker = 0
		self.block_sig_icon = 0
		#######
	def check_date_age(self):
		import RETicker
		fd = RETicker.main.news.get_by_ticker(self.ticker)
		if fd and fd.date_info == 1:
			self.date_label_a.show()
			self.date_label_b.show()
			self.date_label_c.show()
			self.date_hsep_a.show()
			self.date_hsep_b.show()
			self.s_news_age_by_date.show()
		else:
			self.date_label_a.hide()
			self.date_label_b.hide()
			self.date_label_c.hide()
			self.date_hsep_a.hide()
			self.date_hsep_b.hide()
			self.s_news_age_by_date.hide()
	def open_cache_file(self, widget, event):
		def set_cache_file(widget):
			sel.hide()
			if self.iconcache <> sel.get_filename():
				self.iconcache = sel.get_filename()
				self.emit('changed_Page',self)
				self.check_iconcache(None)
		def exit(widget):
			sel.hide()
		if event.button == 1:
			sel = g.FileSelection()
			if self.iconcache <> "":
				sel.set_filename(self.iconcache)
			else: sel.set_filename(self.def_iconcache)
			sel.connect("destroy", exit)
			sel.ok_button.connect("clicked", set_cache_file)
			sel.cancel_button.connect("clicked", exit)
			sel.show()
	def activate_Signals(self):
		if v: print "activate Page-Item SIGNALs"
		if not(self.sig_ticker): self.sig_ticker = self.e_ticker.connect('changed',self.check_ticker)
		if not(self.sig_icon): self.sig_icon = self.e_icon.connect('changed',self.check_icon)
		if not(self.sig_iconcache): self.sig_iconcache = self.e_iconcache.connect('changed',self.check_iconcache)
		if not(self.sig_shownews): self.sig_shownews = self.s_shownews.connect('value-changed',self.check_shownews)
		if not(self.sig_news_age_by_date): self.sig_news_age_by_date = self.s_news_age_by_date.connect('value-changed',self.check_news_age_by_date)
	def deactivate_Signals(self):
		if v: print "deactivate Page-Item SIGNALs"
		if self.sig_ticker:
			self.e_ticker.disconnect(self.sig_ticker); self.sig_ticker = None
		if self.sig_icon:
			self.e_icon.disconnect(self.sig_icon); self.sig_icon = None
		if self.sig_iconcache:
			self.e_iconcache.disconnect(self.sig_iconcache); self.sig_iconcache = None
		if self.sig_shownews:
			self.s_shownews.disconnect(self.sig_shownews); self.sig_shownews = None
		if self.sig_news_age_by_date:
			self.s_news_age_by_date.disconnect(self.sig_news_age_by_date); self.sig_news_age_by_date = None
	def fetch_icon(self, widget, event):
		url = self.icon
		if url == "": url = self.def_icon
		#print url
		file = self.iconcache
		if file == "": file = self.def_iconcache
		self.icon_image_tab.get_from_uri(self.http(url),file)
	def check_shownews(self,value):
		self.shownews = int(self.s_shownews.get_value())
		if v: print "changed shownews"
		self.emit('changed_Page',self)
	def check_news_age_by_date(self,value):
		self.news_age_by_date = int(self.s_news_age_by_date.get_value())
		if v: print "changed news_age_by_date"
		self.emit('changed_Page',self)
	def switch_active(self, widget, event):
		if v: print "switch active"
		if self.active == 1: self.active = 0
		else: self.active = 1
		self.check_active()		
	def check_active(self):
		if self.active == 1: self.b_image_2.set_from_stock(g.STOCK_YES,g.ICON_SIZE_SMALL_TOOLBAR)
		else: self.b_image_2.set_from_stock(g.STOCK_NO,g.ICON_SIZE_SMALL_TOOLBAR)
		self.icon_image_tab.set_active(self.active)
		if v: print "changed active"
		self.emit('changed_Page',self)
	def short_dir(self,value):
		if value.find(icon_cache_dir.value) == 0:
			return "[...]"+value[len(icon_cache_dir.value):]
		return value
	def long_dir(self,value):
		if value.find("[...]") == 0:
			return icon_cache_dir.value + value[5:]
		return value	
	def set_ticker(self, wert):
		self.e_ticker.set_text(wert)
		self.check_ticker(None)
	def check_ticker(self,value):
		self.deactivate_Signals()
		self.block_sig_ticker = 1
		self.ticker = self.e_ticker.get_text()
		if self.ticker.find("http://") == 0:
			pos = self.ticker[8:].find("/")
			if pos <> -1: pos = pos + 8
		else:	pos = self.ticker.find("/")
		if pos <> -1: self.def_icon =  self.ticker[:pos] + "/favicon.ico"
		else:	self.def_icon =  self.ticker + "/favicon.ico"
		if self.icon == "":
			self.e_icon.set_text(self.def_icon)
			self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('grey'))
		self.check_icon(None)
		if v: print "changed ticker"
		self.block_sig_ticker = 0
		self.activate_Signals()
		self.emit('changed_Page',self)
	def set_icon(self, wert):
		self.e_icon.set_text(wert)
		self.check_icon(None)
	def check_icon(self,value):
		if not(self.block_sig_ticker): self.deactivate_Signals()
		self.block_sig_icon = 1
		tmp_icon = self.e_icon.get_text()
		if tmp_icon <> self.def_icon:
			self.icon = tmp_icon
			self.def_iconcache = tmp_name(icon_cache_dir.value, tmp_icon)
			self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('black'))
		else: 	
			self.icon = ""
			self.def_iconcache = tmp_name(icon_cache_dir.value, self.def_icon)
			self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('grey'))
		if self.iconcache == "":
			self.e_iconcache.set_text(self.short_dir(self.def_iconcache))
			self.label5.show()
			self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('grey'))
		self.check_iconcache(None)
		if v: print "changed icon"
		if not(self.block_sig_ticker):
			self.block_sig_icon = 0
			self.activate_Signals()
			self.emit('changed_Page',self)
		else: self.block_sig_icon = 0
	def set_iconcache(self, wert):
		self.e_iconcache.set_text(wert)
		self.check_iconcache(None)
	def check_iconcache(self,value):
		if not(self.block_sig_ticker) and not(self.block_sig_icon): self.deactivate_Signals()
		tmp_iconcache = self.e_iconcache.get_text()
		if tmp_iconcache.find("[...]") == 0: self.label5.show()
		else: self.label5.hide()
		if tmp_iconcache <> self.short_dir(self.def_iconcache):
			self.iconcache = tmp_iconcache
			self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('black'))
			self.icon_image_tab.get_from_file(self.long_dir(self.iconcache))
		else:
			self.iconcache = ""
			self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('grey'))
			self.icon_image_tab.get_from_file(self.def_iconcache)
		if v: print "changed iconcache"
		if not(self.block_sig_ticker) and not(self.block_sig_icon):
			self.activate_Signals()
			self.emit('changed_Page',self)
	def http(self, value):
		if value.find("://") == -1: return "http://" + value
		return value		
	def set(self,value):
		if v: print "PAGE set"
		self.active = tool.getintdata(value, "active")
		self.check_active()
		tmp_ticker = tool.getdata(value, "ticker")
		self.set_ticker(tmp_ticker)
		tmp_icon = tool.getdata(value, "icon")
		if tmp_icon <> "": self.set_icon(tmp_icon)
		tmp_iconcache = tool.getdata(value, "iconcache")
		if tmp_iconcache <> "": self.set_iconcache(tmp_iconcache)
		self.shownews = tool.getintdata(value, "shownews")
		self.s_shownews.set_value(self.shownews)
		self.news_age_by_date = tool.getintdata(value, "news_age_by_date")
		self.s_news_age_by_date.set_value(self.news_age_by_date)
		self.check_date_age()
	def _to_xml(self, parent):
		if self.ticker == '': return
		doc = parent.ownerDocument
		root = doc.createElement('source')
		parent.appendChild(root)
		doc = root.ownerDocument
		node = doc.createElement('active')
		node.appendChild(doc.createTextNode(str(self.active)))
		root.appendChild(node)
		node = doc.createElement('ticker')
		node.appendChild(doc.createTextNode(self.ticker))
		root.appendChild(node)
		node = doc.createElement('icon')
		node.appendChild(doc.createTextNode(self.icon))
		root.appendChild(node)
		node = doc.createElement('iconcache')
		if self.iconcache <> "":
			node.appendChild(doc.createTextNode(self.long_dir(self.iconcache)))
		else:
			node.appendChild(doc.createTextNode(""))
		root.appendChild(node)
		node = doc.createElement('shownews')
		node.appendChild(doc.createTextNode(str(self.shownews)))
		root.appendChild(node)
		node = doc.createElement('news_age_by_date')
		node.appendChild(doc.createTextNode(str(self.news_age_by_date)))
		root.appendChild(node)

def tmp_name(cache, url):
	pos = url.find("http://")
	if pos <> -1: url = url[pos+7:]
	while 1:
		pos = url.find("/")
		if pos <> -1:
			url = url[:pos] + "_" + url[pos+1:]
		else: break
	return cache + "/" + url
	
class Help_Container(g.Frame):
	def __init__(self):
		g.Frame.__init__(self)
		swin=g.ScrolledWindow()
		swin.set_policy(g.POLICY_AUTOMATIC,g.POLICY_AUTOMATIC)
		swin.show()
		self.add(swin)
		textbuf = g.TextBuffer(None)
 		file = open( rox.app_dir + "/" + "Help.txt","r")
		text = unicode(file.read(), 'iso-8859-1')
		file.close()
		ebox = g.EventBox()
		ebox.show()
		ebox.modify_bg(g.STATE_NORMAL,ebox.get_colormap().alloc_color('white'))
		vbox = g.VBox()
		vbox.show()
		hbox = g.HBox()
		hbox.show()
		label = g.Label()
		label.set_markup(text)
		label.set_line_wrap(True)
		label.set_size_request(280,-1)
		label.show()
		hbox.pack_start(label,g.FALSE,g.FALSE,15)
		#vbox.pack_start(label,g.FALSE,g.FALSE,10)
		vbox.pack_start(hbox,g.FALSE,g.FALSE,0)
		ebox.add(vbox)
		swin.add_with_viewport(ebox)
		self.set_size_request(345,300)
		self.show()


class TickPrefs_Container(g.Fixed):
	def __init__(self):
		global feeds
		feeds = []
		self.pageCount = 0
		g.Fixed.__init__(self)
		self.set_size_request(345,230)
		self.notebook = g.Notebook()
		self.notebook.show()
		self.put(self.notebook,3,22)
		self.notebook.set_size_request(332, 184)
		self.notebook.set_scrollable(True)
		button1 = g.Button("refresh Sources")
		button1.show()
		self.put (button1, 3, 0)
		button1.set_size_request(90,18)
		button1.connect('clicked', self.refresh)
		button2 = g.Button("new Source")
		button2.show()
		self.put (button2, 185, 0)
		button2.set_size_request(70,18)
		button2.connect('clicked', self.add_Page)
		button4 = g.Button("kill Source")
		button4.show()
		self.put (button4, 265, 0)
		button4.set_size_request(70,18)
		button4.connect('clicked', self.kill_Page)
		label = g.Label("click on images to [activate] / [fetch icon] / [choose path]")
		label.modify_fg(g.STATE_NORMAL, g.gdk.color_parse('#800000'))
		label.show()
		self.put(label,70,205)
	def kill_Page(self, value):
		killpage = self.notebook.get_nth_page(self.notebook.get_current_page())
		change = killpage.ticker <> "" or \
			killpage.icon <> ""
		self.notebook.remove_page(self.notebook.get_current_page())
		#self.pages = []
		self.pageCount -= 1
		if change: self.emit('changed_Conti',self)
	def hello_(self, value, value2):
		if v: print "SIGNAL: changed Page " + str(self.notebook.get_current_page())
		self.emit('changed_Conti',self)
	def refresh(self, value):
		import RETicker
		tasks.Task(RETicker.refresh_ticker())
	def add_Page(self,value):
		newpage = ConfigPage()
		newpage.show()
		self.notebook.append_page(newpage, newpage.icon_image_tab)
		self.pageCount += 1
		newpage.activate_Signals()
		newpage.connect('changed_Page', self.hello_)
		self.notebook.set_current_page(self.notebook.page_num(newpage))		
	def add_Page_Set(self,value):
		newpage = ConfigPage()
		newpage.show()
		self.notebook.append_page(newpage, newpage.icon_image_tab)
		self.pageCount += 1
		newpage.set(value)
		newpage.activate_Signals()
		newpage.connect('changed_Page', self.hello_)
	def get_xml(self):
		from xml.dom.minidom import Document
		doc = Document()
		root = doc.createElement('Options')
		doc.appendChild(root)
		for i in range(0, self.pageCount):
			self.notebook.get_nth_page(i)._to_xml(root)
		return doc		
	def get_value(self):
		doc = self.get_xml()
		return doc.toxml()
	def load_config(self, config):
		currentPage = self.notebook.get_current_page()
		for i in range(0,self.pageCount):
			self.notebook.remove_page(0)
		self.pageCount = 0
		from xml.dom import Node, minidom
		doc = minidom.parseString(unxml(config))
		for i in doc.getElementsByTagName("source"):
			self.add_Page_Set(i)
		if currentPage <> -1: self.notebook.set_current_page(currentPage)

gobject.signal_new("changed_Conti", TickPrefs_Container, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))
		
gobject.signal_new("changed_Page", ConfigPage, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))


class TickPrefs(rox.Window):
	def __init__(self):
		rox.Window.__init__(self)
		self.pages = []
		table = g.Table()
		table.show()
		self.add(table)
		fixed = TickPrefs_Container()
		fixed.show()
		table.add(fixed)

#test = TickPrefs()
#test.set(sources)
#test = TickerPrefs()
#test.show()
#test.show_all()

#test.save_config()
#rox.mainloop()
