#!/usr/bin/env python
from __future__ import generators
import findrox; findrox.version(1,9,12)
import rox
from rox import applet, g, Menu, InfoWin, tasks, ButtonMixed, choices, options
from rox.Menu import Menu, set_save_name
from Options import *

from rox import app_options

_options_box = None

v = 0

def open_menu(widget, event, position_menu):
	menu.popup(widget, event, position_menu)

def set_save(program):
	global prog
	prog = program
	set_save_name(program)
	global menu
	global main
	menu = Menu('main', [
        ('/Quit',		'quit',		'<StockItem>',  '', g.STOCK_QUIT),
 	('/Help',          	'help',         '<StockItem>',  '', g.STOCK_HELP),
        ('/Info',          	'info',         '<StockItem>',  '', g.STOCK_DIALOG_INFO),
        ('/Show Window',        'show_window',  '<StockItem>',  '', g.STOCK_INDEX),
	('/Options',            'show_options', '<StockItem>',  '', g.STOCK_PREFERENCES),
	('/Refresh',            'refresh_ticker', '<StockItem>',  '', g.STOCK_REFRESH),
        ('/Next Msg',            'update_ticker', '<StockItem>',  '', g.STOCK_GO_FORWARD)
        ])



def remove_icons():
	global feeds
	for fd in feeds:
		icon = str(fd['icon'])
		if os.path.exists(icon): os.remove(icon)
def info():
        InfoWin.infowin(" " + Version + " ")

def help():
	Help = g.Window()
	HelpTab = Help_Container()
	Help.add(HelpTab)
	Help.show()

def show_options():
	tasks.Task(edit_options())
	#rox.edit_options()
	
def edit_options(options_file = None):
	"""Edit the app_options (set using setup_app_options()) using the GUI
	specified in 'options_file' (default <app_dir>/Options.xml).
	If this function is called again while the box is still open, the
	old box will be redisplayed to the user."""
#	assert app_options

	yield None
	global _options_box
	if _options_box:
		_options_box.present()
		return
	
	if not options_file:
		options_file = os.path.join(rox.app_dir, 'Options.xml')
	
	_options_box = OptionsBox(app_options, options_file)

	def closed(widget):
		global _options_box
		assert _options_box == widget
		_options_box = None
	_options_box.connect('destroy', closed)
	_options_box.open()

