#!/usr/bin/env python
import re
def unxml(string):
	""" removes tags and entities from a given string and returns
	new string """
	lt=re.compile('&lt;')
	gt=re.compile('&gt;')
	amp=re.compile('&amp;')
	auml=re.compile('&auml;|&#228;')
	Auml=re.compile('&Auml;')
	ouml=re.compile('&ouml;|&#246;')
	Ouml=re.compile('&Ouml;')
	uuml=re.compile('&uuml;|&#252;')
	Uuml=re.compile('&Uuml;')
	szlig=re.compile('&szlig;|&#223;')
	quot=re.compile('&quot;')
	apos=re.compile('&apos;')
	#tag=re.compile('<.*?>')
	(string,null)=amp.subn("&",string,0)
	(string,null)=auml.subn(u'\xE4',string,0)
	(string,null)=Auml.subn(u'\xC4',string,0)
	(string,null)=ouml.subn(u'\xF6',string,0)
	(string,null)=Ouml.subn(u'\xD5',string,0)
	(string,null)=Uuml.subn(u'\xDC',string,0)
	(string,null)=szlig.subn(u'\xDF',string,0)
	(string,null)=uuml.subn(u'\xFC',string,0)
	(string,null)=quot.subn('"',string,0)
	(string,null)=apos.subn("'",string,0)
	(string,null)=lt.subn("<",string,0)
	(string,null)=gt.subn(">",string,0)
	#(string,null)=tag.subn("",string,0)
	return string

import time
def conv_iso_time(date):
	if date[-5] == "+": date = date[:-5]
#		return time.mktime(time.strptime(date[:-5], "%Y-%m-%dT%H:%M:%S")) \
#			+ 60*60*int(date[-4:-2]) + 60* int(date[-2:])
	if date[-5] == "-": date = date[:-5]
#		return time.mktime(time.strptime(date[:-5], "%Y-%m-%dT%H:%M:%S")) \
#			- 60*60*int(date[-4:-2]) - 60* int(date[-2:])
	if date[-6] == "+": date = date[:-6]
#		return time.mktime(time.strptime(date[:-6], "%Y-%m-%dT%H:%M:%S")) \
#			+ 60*60*int(date[-5:-3]) + 60* int(date[-2:])
	if date[-6] == "-": date = date[:-6]
#		return time.mktime(time.strptime(date[:-6], "%Y-%m-%dT%H:%M:%S")) \
#			- 60*60*int(date[-5:-3]) - 60* int(date[-2:])
	return time.mktime(time.strptime(date, "%Y-%m-%dT%H:%M:%S"))

def getdata(channel,name):
	c_name_s=channel.getElementsByTagName(name)
	c_name = ""
	if c_name_s:
		for t in c_name_s[0].childNodes:
			if t: c_name+=t.data
	return c_name

def getintdata(channel,name):
	c_name_s=channel.getElementsByTagName(name)
	c_name = ""
	if c_name_s:
		for t in c_name_s[0].childNodes:
			if t: c_name+=t.data
	if c_name == "": return 0
	else: return int(c_name)

def getfloatdata(channel,name):
	c_name_s=channel.getElementsByTagName(name)
	c_name = ""
	if c_name_s:
		for t in c_name_s[0].childNodes:
			if t: c_name+=t.data
	if c_name == "": return 0
	else: return float(c_name)

def gettimedata(channel,name):
	c_name_s=channel.getElementsByTagName(name)
	c_name = ""
	if c_name_s:
		for t in c_name_s[0].childNodes:
			if t: c_name+=t.data
	if c_name == "": return 0
	else: return float(conv_iso_time(c_name))
